// Global Namespace
ABB.Simulator.Global.Ready						=false;			//simulator loaded
ABB.Simulator.Global.isOn						=false;
ABB.Simulator.Global.xmlDoc;									// Device XML Document
ABB.Simulator.Global.xmlCards;									// XML Menu Cards
ABB.Simulator.Global.xmlValues;									// XML Value (value nodes - parameters)
ABB.Simulator.Global.valueNodeList;								// All value/parameter nodes
ABB.Simulator.Global.card;										// Active XML card
ABB.Simulator.Global.selectedValue;								// Current selected value for editing
ABB.Simulator.Global.storedValue;								// Store original value if user aborts editing
ABB.Simulator.Global.activeSettingGroup			= 1;			// Current active setting group
ABB.Simulator.Global.password					= new Array("0001", "0002", "0003", "0004"); // Default passwords: Viewer, Operator, Engineer, Admin
ABB.Simulator.Global.maxTimeOut					= 300000;
ABB.Simulator.Global.settingsChanged			= false;

ABB.Simulator.Global.dspposition			= 0;				// Display position (overloaded!)
ABB.Simulator.Global.optionposition			= 0;				// Display position in group mode
ABB.Simulator.Global.cursorpos				= 0;				// Cursor Position
ABB.Simulator.Global.currentid				= '';				// Active Card Id

ABB.Simulator.Global.userLevel				= 4;				//0 = Not logged in				
																// 1 = Viewer		basic read + advanced read
																// 2=Operator		basic read/write + advanced read
																// 3=Engineer		basic read/write + advanced read/write
																// 4=Administrator	basic read/write + advanced read/write

ABB.Simulator.Global.binaryNumber			= 0;				// to edit one bit at time
ABB.Simulator.Global.binaryState			= 0;

ABB.Simulator.Global.eventCounter			= 0;

ABB.Simulator.Global.showDialog				= false;			//Global flag if dialog is shown on screen

ABB.Simulator.Global.editGroupValue			= 1;				//Selected SG value for editing

ABB.Simulator.Global.showMin				= false;			//Show min value in edit mode
ABB.Simulator.Global.showMax				= false;			//Show max value in edit mode

ABB.Simulator.Global.display;									// Handle to the display object
ABB.Simulator.Global.PAGEHISTORY			= new Array();;		// History array

ABB.Simulator.Global.stateLR				= 0;				// 0 = disabled
																// -1 = L
																// 1 = R 
ABB.Simulator.Global.isClearMenu			= false;	
ABB.Simulator.Global.isAlarm				= false;			// Alarm flag
ABB.Simulator.Global.isStart				= false;			// Start flag
ABB.Simulator.Global.isMonitor				= false;			// Monitor mode is active
ABB.Simulator.Global.breakerOpen			= false;			// breaker is closed
ABB.Simulator.Global.earthingOpen			= true;				// earthing switch is open
ABB.Simulator.Global.currentUp				= false;
ABB.Simulator.Global.timeoutMonitor			= null;				// timeout variable for monitoring mode
ABB.Simulator.Global.timeoutMenu			= null;				// timeout variable 

ABB.Simulator.Global.objSimulator			= null;				// Simulator handle
ABB.Simulator.Global.objSignalDiagram		= null;				// Signal diagram handle
ABB.Simulator.Global.objFaultSimulation		= null;				// Fault Simulation handle (fault simulation panel)
ABB.Simulator.Global.objSingleLineDiagram	= null;				// Single Line Diagram handle (fault simulation panel)
ABB.Simulator.Global.objErrorSimulation		= null;				// Error simulation handle

ABB.Simulator.Global.buttonEvent			= new Array(false, false, false, false, false);


ABB.Simulator.Global.SetSimulatorObject = function (obj) {
	ABB.Simulator.Global.objSimulator = obj;
}

ABB.Simulator.Global.GetSimulatorObject = function () {
	return ABB.Simulator.Global.objSimulator;
}

ABB.Simulator.Global.SetFaultSimulationPanel = function (obj) {
	ABB.Simulator.Global.objFaultSimulation = obj;
}

ABB.Simulator.Global.GetFaultSimulationPanel = function () {
	return ABB.Simulator.Global.objFaultSimulation;
}

ABB.Simulator.Global.SetSingleLineDiagram = function (obj) {
	ABB.Simulator.Global.objSingleLineDiagram = obj;
}

ABB.Simulator.Global.GetSingleLineDiagram = function () {
	return ABB.Simulator.Global.objSingleLineDiagram;
}

ABB.Simulator.Global.SetErrorSimulationObject = function (obj) {
	ABB.Simulator.Global.objErrorSimulation = obj;
}

ABB.Simulator.Global.GetErrorSimulationObject = function () {
	return ABB.Simulator.Global.objErrorSimulation;
}

ABB.Simulator.Global.ResetValues = function () {
		ABB.Simulator.Global.dspposition = 0;
		ABB.Simulator.Global.cursorpos = 0;
}

ABB.Simulator.Global.ResetCursorPos = function () {
		ABB.Simulator.Global.cursorpos = 0;
}

ABB.Simulator.Global.timeoutTripStateLed = function () {
		var objLEDs = new ABB.Simulator.UI.LEDs();
		objLEDs.SetLedTripState( ABB.Simulator.Global.Constants.LEDStateRed );
} 

ABB.Simulator.Global.timeoutLedTest = function () {
		var objLEDs = new ABB.Simulator.UI.LEDs();
		objLEDs.ResetAll();
		objLEDs.SetLedReadyState( ABB.Simulator.Global.Constants.LEDStateGreen );
} 

ABB.Simulator.Global.activateMonitor = function () {
		if( ABB.Simulator.Global.isAlarm == true || ABB.Simulator.Global.isMonitor == true ) return;
		clearTimeout(ABB.Simulator.Global.timeoutMenu);
		ABB.Simulator.Global.isMonitor = true;
		ABB.Simulator.UI.CardMode.DrawMonitorMode();
}


ABB.Simulator.Global.generateEvent = function ( eventID ) {
		
		var ts = new Date();			//Time stamp
		
		var hr = ""+ts.getHours();	if(hr.length == 1) hr="0"+hr; 
		var min = ""+ts.getMinutes(); if(min.length == 1) min="0"+min;
		var sec = ""+ts.getSeconds(); if(sec.length == 1) sec="0"+sec;
		var msec = ""+ts.getMilliseconds();
		
		var timeStr = ""+hr+"."+min+";"+sec+"."+msec;
		
		var yyyy = ""+ts.getFullYear(); if(yyyy.length == 1) yyyy="0"+yyyy;
		var mm = ""+(ts.getMonth()+1); if(mm.length == 1) mm="0"+mm;
		var dd = ""+ts.getDate(); if(dd.length == 1) dd="0"+dd;
		
		var dateStr = ""+yyyy.substring(2)+"-"+mm+"-"+dd;
		
		switch( eventID ) {
				case "OverCurrent":
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_1", timeStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_2", dateStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_3", "5.43" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_4", "5.41" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_5", "5.46" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_6", "10" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_7", "70" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_8", "100" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_9", "8" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_10", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_11", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_12", "0.01" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_13", "0" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_14", "64" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_15", "65" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_16", "0" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_17", "1" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_18", "0" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_19", "0" );
						
						break;	
				case "ThermalOverload":
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_1", timeStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_2", dateStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_3", "1.23" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_4", "1.25" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_5", "1.24" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_6", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_7", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_8", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_9", "1" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_10", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_11", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_12", "0.01" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_13", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_14", "65" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_15", "100" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_16", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_17", "1" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_18", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_19", "0" );
						break;				
				case "ArcProtection":
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_1", timeStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_2", dateStr );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_3", "24.1" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_4", "23.2" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_5", "1.0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_6", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_7", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_8", "90" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_9", "2" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_10", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_11", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_12", "0" );						
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_13", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_14", "65" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_15", "65" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_16", "0" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_17", "1" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_18", "100" );
						ABB.Simulator.UI.CardMode.setValueNode( "idEvent1_19", "0" );
						break;
			}
}

ABB.Simulator.Global.rotateEvents = function () {
		
		var temp = new Array(false, false, false, false, false);
		var LoopX = 0;
		var LoopY = 0;
		
		for(LoopX=5; LoopX>1; LoopX--) {
			for(LoopY=1; LoopY<=18; LoopY++) {
				var indX = "" + LoopX;
				var indY = "" + LoopY;
				var setID = "idEvent" + indX + "_" + indY;		//Copy To
				var number = "" + (LoopX-1);
				var getID = "idEvent" + number + "_" + indY;	//Copy From
				ABB.Simulator.UI.CardMode.setValueNode( setID, ABB.Simulator.UI.CardMode.getValueNode( getID ));	
			}
		}
		
		for(LoopX=1; LoopX<5; LoopX++) {
			if(ABB.Simulator.Global.buttonEvent[LoopX-1]) {
				ABB.Simulator.Global.setSupport(LoopX+1, "1");
				temp[LoopX] = true;
			}
			else {
				ABB.Simulator.Global.setSupport(LoopX+1, "0");
			}
		}
		
		for(var i=0; i<temp.length; i++) {
			ABB.Simulator.Global.buttonEvent[i] = temp[i];
		}
}

ABB.Simulator.Global.setSupport = function ( eventNo, buttonEvent ) {
		
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_12", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_13", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_14", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_15", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_16", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_17", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_18", buttonEvent );
	ABB.Simulator.UI.CardMode.setSupportNode( "idEvent" + eventNo + "_19", buttonEvent );
}

ABB.Simulator.Global.blinkIt = function () {
     if (!document.all) return;
 	else {
		for(i=0;i<document.getElementsByTagName('blink').length;i++){
			s = document.getElementsByTagName('blink')[i].style;
			s.visibility = (s.visibility=='visible') ? 'hidden':'visible';
		}
	}
}

// XML loader
ABB.Simulator.Global.loadXML = function () {
	//load xml file
	// code for IE
	if (window.ActiveXObject) {
		xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async=false;
		xmlDoc.load( ABB.Simulator.Global.Constants.SimulatorXMLFile );
		ABB.SimulatorStart();
	}
	// code for Mozilla, etc.
	else if (document.implementation &&	document.implementation.createDocument) {
		xmlDoc = document.implementation.createDocument("","",null);
		xmlDoc.load( ABB.Simulator.Global.Constants.SimulatorXMLFile );
		xmlDoc.onload	=	ABB.SimulatorStart;
	}
	else {
		alert('Your browser cannot handle this script');
	}
}


ABB.Simulator.Global.ShowWindow = function (pUrl, pWidth, pHeight, pResize, pScroll) {
    var pTop    = (window.screen.availHeight-pHeight) / 2;
    var pLeft   = (window.screen.availWidth-pWidth) / 2;
    var hwnd = window.open(pUrl,"simWin","width="+pWidth+",height="+pHeight+",top="+pTop+",left="+pLeft+",scrollbars="+pScroll+",resizable="+pResize);
	return hwnd;
}