// Namespace: ABB.Simulator.UI.ButtonHandler
ABB.Simulator.UI.ButtonHandler	= function () {
	this.alertDialog = null;
	/**
	 * Public Functions
	 */
	 
	/**
	 * <brief>
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonUp	= function () {
		var oES = ABB.Simulator.Global.GetErrorSimulationObject();				
		
	/*	//if alarm is displayed
		if(ABB.Simulator.Global.isAlarm == true && oES.getAlarmOn() == true) {			
			oES.setAlarmOn(false);
		}*/
		
		if (ABB.Simulator.Global.card.id == ABB.Simulator.Global.Constants.EventMenuId) {
			ABB.Simulator.Global.dspposition--;
			if (ABB.Simulator.Global.dspposition < 0) {
				ABB.Simulator.Global.dspposition = oES.getEventListLength() - 1;
			}
			ABB.Simulator.UI.Display.RefreshDisplay();
			return;
		}
		
		// check if user has pressed "Cancel" button
		if( ABB.Simulator.Global.dspposition == -1 ) {
				ABB.Simulator.Global.dspposition = 0;
				ABB.Simulator.UI.Display.RefreshDisplay();
				return;
		}
		
		// in case root mode has not been loaded
		if(ABB.Simulator.Global.card==null) {
			// load rootmenu
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
			return;
		}
		
		if (ABB.Simulator.Global.showDialog == true) {
			ABB.Simulator.UI.Dialog.ButtonUp();
			return;
		}
		
		
		switch( ABB.Simulator.Global.card.mode) {
			case "RootMode":
			case "MenuNode":
			case "GroupMode":						
				if( ABB.Simulator.Global.dspposition >= 0 ) ABB.Simulator.Global.dspposition = ABB.Simulator.Global.dspposition - 1;
				if( ABB.Simulator.Global.dspposition < 0 ) ABB.Simulator.Global.dspposition = ABB.Simulator.Global.card.content.length-1;
				ABB.Simulator.UI.Display.RefreshDisplay();
			break;
			case "EditMode":
				switch( ABB.Simulator.Global.selectedValue.type ) {
					case "text":
						var value = ABB.Simulator.Global.selectedValue.value;
						var index = value.length - ABB.Simulator.Global.cursorpos - 1;
						var temp = value.charCodeAt(index);
						if (temp < 126 )temp++;
						temp = String.fromCharCode(temp);
						value = setCharAt(value, index, temp);
						ABB.Simulator.Global.selectedValue.value = value;
					break;
					case "numeric":
					case "sgnumeric":
						var value = ABB.Simulator.Global.selectedValue.value;
						value = value.toString();
						var index = value.length - ABB.Simulator.Global.cursorpos - 1;
						var temp = value.charAt(index);
						if ( index < 0) {
							if ( index == -1 && value >= 0) {
								value = value * -1;
							}
							else if ( ABB.Simulator.Global.showMin == true )
								ABB.Simulator.Global.showMin = false;
							else
								ABB.Simulator.Global.showMax = true;
						}
						else if ( temp == '-') {
							value = value * -1;
						}
						else if (temp != '.') {
							if (temp == 9) temp = 0;
							else temp = temp*1 + 1;
							value = setCharAt(value, index, temp);
						}
						ABB.Simulator.Global.selectedValue.value = value;
						//Format number
						ABB.Simulator.Global.selectedValue.value = new Number(ABB.Simulator.Global.selectedValue.value).numberFormat(ABB.Simulator.Global.selectedValue.format);
					break;
					case "option":
					case "sgoption":
						if( ABB.Simulator.Global.optionposition > 0 ) {
							ABB.Simulator.Global.optionposition = ABB.Simulator.Global.optionposition - 1;
						}
						else {
							ABB.Simulator.Global.optionposition = ABB.Simulator.Global.selectedValue.options.length - 1;
						}
					break;
				}
				ABB.Simulator.UI.Display.RefreshDisplay();
			break;
			case "SettingGroupMode":
				
			break;
		}
	}


	/**
	 * <brief>
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonDown = function () {
	
		var oES = ABB.Simulator.Global.GetErrorSimulationObject();			
		/*
		//if alarm is displayed
		if(ABB.Simulator.Global.isAlarm == true && oES.getAlarmOn() == true) {			
			oES.setAlarmOn(false);
		}*/	
		
		if (ABB.Simulator.Global.card.id == ABB.Simulator.Global.Constants.EventMenuId) {
			ABB.Simulator.Global.dspposition++;
			var length = oES.getEventListLength();
			if (ABB.Simulator.Global.dspposition >= length) {
				ABB.Simulator.Global.dspposition = 0;
			}
			ABB.Simulator.UI.Display.RefreshDisplay();
			return;
		}
		
		// check if user has pressed "Cancel" button
		if( ABB.Simulator.Global.dspposition == -1 ) {
				ABB.Simulator.Global.dspposition = 0;
				ABB.Simulator.UI.Display.RefreshDisplay();
		}
		
		// in case root mode has not been loaded
		if(ABB.Simulator.Global.card==null) {
			// load rootmenu
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
			return;
		}
		
		if (ABB.Simulator.Global.showDialog == true) {
			ABB.Simulator.UI.Dialog.ButtonDown();
			return;
		}
		
		
		switch( ABB.Simulator.Global.card.mode ) {
				case "RootMode":
				case "MenuNode":
				case "GroupMode":
						if( ABB.Simulator.Global.dspposition < ABB.Simulator.Global.card.content.length-1 ) ABB.Simulator.Global.dspposition = ABB.Simulator.Global.dspposition + 1;
						else ABB.Simulator.Global.dspposition = 0;
						ABB.Simulator.UI.Display.RefreshDisplay();
						break;
				case "EditMode":
			        switch( ABB.Simulator.Global.selectedValue.type ) {
			            case "text":
							var value = ABB.Simulator.Global.selectedValue.value;
							var index = value.length - ABB.Simulator.Global.cursorpos - 1;
							//var temp = value.charAt(index);
							var temp = value.charCodeAt(index);
							if (temp > 32 ) temp--;
							temp = String.fromCharCode(temp);
							value = setCharAt(value, index, temp);
							ABB.Simulator.Global.selectedValue.value = value;
						break;
			            case "numeric":
						case "sgnumeric":
							var value = ABB.Simulator.Global.selectedValue.value;
							value = value.toString();
							var index = value.length - ABB.Simulator.Global.cursorpos - 1;
							var temp = value.charAt(index);
							if ( index < 0) {
								if ( index == -1 && value >= 0) {
									value = value * -1;
								}
								else if ( ABB.Simulator.Global.showMax == true )
									ABB.Simulator.Global.showMax = false;
								else
									ABB.Simulator.Global.showMin = true;
							}
							else if ( temp == '-') {
								value = value * -1;
							}
							else if (temp != '.') {
								if (temp == 0) temp = 9;
								else temp = temp*1 - 1;
								value = setCharAt(value, index, temp);
							}
							ABB.Simulator.Global.selectedValue.value = value;
							//Format number
							ABB.Simulator.Global.selectedValue.value = new Number(ABB.Simulator.Global.selectedValue.value).numberFormat(ABB.Simulator.Global.selectedValue.format);
						break;
						case "option":
						case "sgoption":
							if( ABB.Simulator.Global.optionposition < ABB.Simulator.Global.selectedValue.options.length - 1 ) {
								ABB.Simulator.Global.optionposition = (ABB.Simulator.Global.optionposition * 1) + 1;
							}
							else {
								ABB.Simulator.Global.optionposition = 0;
							}
						break;
					}
					ABB.Simulator.UI.Display.RefreshDisplay();
				break;
				case "SettingGroupMode":
					
				break;
		}
	}
	
	
	/**
	 * Function is called when HMI Left button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonLeft	= function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0  && ABB.Simulator.Global.showDialog	 == false) return;
		
		var oES = ABB.Simulator.Global.GetErrorSimulationObject();		
		
			/*	
		//if alarm is displayed
		if(ABB.Simulator.Global.isAlarm == true && oES.getAlarmOn() == true) {			
			oES.setAlarmOn(false);
		}	*/	
		
		// check if user has pressed "Cancel" button
		if( ABB.Simulator.Global.dspposition == -1 ) {
				ABB.Simulator.Global.dspposition = 0;
				ABB.Simulator.UI.Display.RefreshDisplay();
				return;
		}
		
		if (ABB.Simulator.Global.isMonitor) ABB.Simulator.Global.isMonitor = false;
		
		// in case root mode has not been loaded
		if(ABB.Simulator.Global.card==null) {
			// load rootmenu
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
			return;
		}
		
		if (ABB.Simulator.Global.showDialog == true) {
			ABB.Simulator.UI.Dialog.ButtonLeft();
			return;
		}
		if( ABB.Simulator.Global.PAGEHISTORY.length > 0 ) {
			if ( ABB.Simulator.Global.PAGEHISTORY[ ABB.Simulator.Global.PAGEHISTORY.length -1].id == ABB.Simulator.Global.Constants.XMLRootId && ABB.Simulator.Global.settingsChanged) {
				ABB.Simulator.UI.Dialog.ModalDialog( "Commit settings?", "Question", "YesNoCancel", 0, "commitSettings" );
				ABB.Simulator.UI.Dialog.ShowDialog();
				return;
			}
		}
		
		ABB.Simulator.Global.showMin = false;
		ABB.Simulator.Global.showMax = false;
		
		switch( ABB.Simulator.Global.card.mode ) {
				case "MenuNode":
				case "GroupMode":
						//User has exited SG selection
						if(ABB.Simulator.Global.isClearMenu == true) {
							ABB.Simulator.Global.isClearMenu == false;
						}
						clearTimeout(ABB.Simulator.Global.timeoutMonitor);
						ABB.Simulator.Global.editGroup = false;
						ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
						break;
				case "EditMode":
					switch( ABB.Simulator.Global.selectedValue.type ) {
						case "numeric":
						case "time":
						case "date":
						case "sgnumeric":
							if( ABB.Simulator.Global.cursorpos < ABB.Simulator.Global.selectedValue.format.length + 1 ) {
								ABB.Simulator.Global.cursorpos = ABB.Simulator.Global.cursorpos + 1;
								ABB.Simulator.UI.Display.RefreshDisplay();
								break;
							}
							if( ABB.Simulator.Global.cursorpos == ABB.Simulator.Global.selectedValue.format.length + 1 ) {
								ABB.Simulator.Global.cursorpos = 0;
								ABB.Simulator.UI.Display.RefreshDisplay();
								break;											
							}
						case "text":
							if( ABB.Simulator.Global.cursorpos < 19 ) {
								ABB.Simulator.Global.cursorpos = ABB.Simulator.Global.cursorpos + 1;
								ABB.Simulator.UI.Display.RefreshDisplay();
								break;
							}
							if( ABB.Simulator.Global.cursorpos == 19 ) {
								ABB.Simulator.Global.cursorpos = 0;
								ABB.Simulator.UI.Display.RefreshDisplay();
								break;											
							}
						case "binary":
						case "sgbinary":
							if( ABB.Simulator.Global.binaryNumber < ABB.Simulator.Global.selectedValue.max - 1 ) ABB.Simulator.Global.binaryNumber = ABB.Simulator.Global.binaryNumber + 1;
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
					}
				break;
				case "SettingGroupMode":
					ABB.Simulator.Global.card.mode = "GroupMode";
					ABB.Simulator.UI.Display.GetPageHistory();
					ABB.Simulator.UI.Display.RefreshDisplay();
				break;
		}
	}

	
	/**
	 * Function is called when HMI Right button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonRight = function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 && ABB.Simulator.Global.showDialog	 == false) return;
		var oES = ABB.Simulator.Global.GetErrorSimulationObject();
		/*		
		//if alarm is displayed
		if(ABB.Simulator.Global.isAlarm == true && oES.getAlarmOn() == true) {			
			oES.setAlarmOn(false);
		}
		*/
		// when monitoring mode is active
		if( ABB.Simulator.Global.isMonitor == true && !ABB.Simulator.Global.showDialog) return;
		
		// check if user has pressed "Cancel" button
		if( ABB.Simulator.Global.dspposition == -1 ) {
				ABB.Simulator.Global.dspposition = 0;
				ABB.Simulator.UI.Display.RefreshDisplay();
				return;
		}
		
		// in case root mode has not been loaded
		if(ABB.Simulator.Global.card==null) {
			// load rootmenu
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
			return;
		}
		
		if (ABB.Simulator.Global.showDialog == true) {
			ABB.Simulator.UI.Dialog.ButtonRight();
			return;
		}
		if (ABB.Simulator.Global.card.headline == "Events") return; 
		
		//In case SG are displayed
		//Select group under editing
		if ( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].text == "Settings" && ABB.Simulator.Global.card.headline == "Settings" ) {
			ABB.Simulator.UI.Dialog.SelectSGDialog();
			ABB.Simulator.UI.Dialog.ShowDialog(); 
		}
		
		ABB.Simulator.Global.showMin = false;
		ABB.Simulator.Global.showMax = false;
		
		switch( ABB.Simulator.Global.card.mode ) {
			case "RootMode":
			case "MenuNode":
				ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].link , "forward" );
			break;
			case "EditMode":
				switch( ABB.Simulator.Global.selectedValue.type ) {
					case "numeric":
					case "sgnumeric":
						if( ABB.Simulator.Global.cursorpos > 0 ) {
							ABB.Simulator.Global.cursorpos = ABB.Simulator.Global.cursorpos - 1;											
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
						}
						if( ABB.Simulator.Global.cursorpos == 0 ) {
							ABB.Simulator.Global.cursorpos = ABB.Simulator.Global.selectedValue.format.length + 1;
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
						}
					case "text":
					if( ABB.Simulator.Global.cursorpos > 0 ) {
							ABB.Simulator.Global.cursorpos = ABB.Simulator.Global.cursorpos - 1;											
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
						}
						if( ABB.Simulator.Global.cursorpos == 0 ) {
							ABB.Simulator.Global.cursorpos = 19;
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
						}
				}
				break;
			case "GroupMode":		// when Setting Group value is selected
				switch( ABB.Simulator.Global.selectedValue.type ) {
					case "sgnumeric":
						ABB.Simulator.Global.card.mode = "SettingGroupMode";
						ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
						ABB.Simulator.Global.ResetCursorPos();
						ABB.Simulator.UI.Display.RefreshDisplay();
					break;
					case "sgoption":
						ABB.Simulator.Global.card.mode = "SettingGroupMode";
						ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
						ABB.Simulator.Global.ResetCursorPos();
						ABB.Simulator.UI.Display.RefreshDisplay();
					break;
					case "node":										
						ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].link , "forward" );
					break;
					case "event":										
						if(ABB.Simulator.UI.CardMode.GetInclusive( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].link )) {
							ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].link , "forward" );
						}
					break;
				}
			break;
		}
	}

	/**
	 * Function is called when HMI Enter button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonEnter		= function () {
		/**
		 * If user is not logged
		 */
		if (ABB.Simulator.Global.userLevel	== 0  && ABB.Simulator.UI.Dialog.dialogType != 1 && ABB.Simulator.UI.Dialog.dialogType != 2 ) return;
		// when alarm is active
		if( ABB.Simulator.Global.isMonitor == true && !ABB.Simulator.Global.showDialog && !ABB.Simulator.Global.isClearMenu) return;
		
		// in case root mode has not been loaded, do nothing.
		if(ABB.Simulator.Global.card==null) {
			return;
		}		
		
		/**
		 *  Handle dialog results
		 */
		if (ABB.Simulator.Global.showDialog == true) {
			switch( ABB.Simulator.UI.Dialog.dialogType ) {
				case 0:	// Modal Dialog
					dialogresult = ABB.Simulator.UI.Dialog.GetDialogResult();
					if ( ABB.Simulator.UI.Dialog.type == "logout" && dialogresult == "Yes" ){
						if (ABB.Simulator.UI.CardMode.getValueNode(ABB.Simulator.Global.Constants.LocalAuthorizationId) == 1) {
							ABB.Simulator.UI.Display.RefreshDisplay();
							break;
						}
						ABB.Simulator.Global.userLevel = 0;
						ABB.Simulator.Global.isClearMenu = false;
						ABB.Simulator.Global.isMonitor = false;						
						ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
						ABB.Simulator.UI.Display.ClearPageHistory();
					}
					else if ( ABB.Simulator.UI.Dialog.type == "commitSettings" ) {
						switch( dialogresult ) {
							case "Yes":
								ABB.Simulator.Global.settingsChanged = false;
								clearTimeout(ABB.Simulator.Global.timeoutMonitor);
								ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
								ABB.Simulator.UI.Display.ClearPageHistory();
							break;
							case "No":
								ABB.Simulator.Global.settingsChanged = false;
								ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
								ABB.Simulator.UI.Display.ClearPageHistory();
							break;
							case "Cancel":
							break;
						}
					}
					else if (ABB.Simulator.UI.Dialog.type == "closeBreaker" && dialogresult == "Yes") {
						var oSLD = ABB.Simulator.Global.GetSingleLineDiagram();
						if (oSLD) {
							oSLD.CloseBreaker();
						}
						else if (ABB.Simulator.Global.earthingOpen){
							ABB.Simulator.Global.breakerOpen = false
						}
					}
					else if (ABB.Simulator.UI.Dialog.type == "openBreaker" && dialogresult == "Yes") {
						//open the breaker in Fault Simulation Panel
						var oSLD = ABB.Simulator.Global.GetSingleLineDiagram();
						if ( ABB.Simulator.Global.stateLR !=1 ) {
							if ( oSLD ) {
								oSLD.OpenBreaker();
							}
							else {
								ABB.Simulator.Global.breakerOpen = true
							}
						}
					}
					ABB.Simulator.UI.Display.RefreshDisplay();
				break;
				case 1: //Login Dialog 
					this.userLevel = ABB.Simulator.UI.Dialog.GetDialogResult();
					ABB.Simulator.UI.Dialog.SetPasswordDialog( this.userLevel );
					ABB.Simulator.UI.Dialog.ShowDialog();
				break;
				case 2:	//Enter password Dialog
					if (ABB.Simulator.UI.Dialog.type == "LRpass") {
						dialogresult = ABB.Simulator.UI.Dialog.GetDialogResult();
						if ( dialogresult == ABB.Simulator.Global.password[1] ) {
							ABB.Simulator.Global.userLevel = 2;
							changeLR();
							ABB.Simulator.UI.Display.RefreshDisplay();
						}
						else {
							ABB.Simulator.UI.Dialog.AlertDialog( "Wrong Password", "Error" );
							ABB.Simulator.UI.Dialog.ShowDialog();
							setTimeout('ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );', 3000);
							ABB.Simulator.Global.showDialog = false;
						}
					}
					else {
						dialogresult = ABB.Simulator.UI.Dialog.GetDialogResult();
						if ( dialogresult == ABB.Simulator.Global.password[this.userLevel - 1] ) {
							ABB.Simulator.Global.userLevel = this.userLevel;
							ABB.Simulator.UI.Display.RefreshDisplay();
						}
						else {
							ABB.Simulator.UI.Dialog.AlertDialog( "Wrong Password", "Error" );
							ABB.Simulator.UI.Dialog.ShowDialog();
							setTimeout('ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );', 3000);
							ABB.Simulator.Global.showDialog = false;
						}
					}
				break;
				case 3:	//Select Setting Group Dialog
					ABB.Simulator.UI.Dialog.GetDialogResult();
					ABB.Simulator.UI.Display.RefreshDisplay();
				break;
				case 4:	//Alert Dialog
					//ABB.Simulator.UI.Dialog.GetDialogResult();
					//ABB.Simulator.UI.Display.RefreshDisplay();
				break;
			}
			return;
		}
		
		switch( ABB.Simulator.Global.card.mode ) {
			case "GroupMode":		// to enter EditMode
				var access = this.CheckAccess();
				if ( access == true ) {
					switch( ABB.Simulator.Global.selectedValue.type ) {
						case "numeric":
							ABB.Simulator.Global.binaryNumber = 0;
							ABB.Simulator.Global.card.mode = "EditMode";
							ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
							ABB.Simulator.Global.storedValue = ABB.Simulator.Global.selectedValue.value;
							ABB.Simulator.UI.Display.RefreshDisplay();
						break;
						case "option":
						case "enum":
							ABB.Simulator.Global.card.mode = "EditMode";
							ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
							ABB.Simulator.Global.optionposition = ABB.Simulator.Global.selectedValue.activeoption;
							ABB.Simulator.Global.storedValue = ABB.Simulator.Global.selectedValue.activeoption;
							ABB.Simulator.UI.Display.RefreshDisplay();
						break;
						case "text":
							ABB.Simulator.Global.card.mode = "EditMode";
							ABB.Simulator.Global.cursorpos = 18;
							ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
							ABB.Simulator.Global.storedValue = ABB.Simulator.Global.selectedValue.value;
							ABB.Simulator.UI.Display.RefreshDisplay();
						break;
					}
				}
			break;
			case "EditMode":		// to exit EditMode
				ABB.Simulator.Global.settingsChanged = true;
				switch( ABB.Simulator.Global.selectedValue.type ) {
					case "option":																	// save selected option/enum
						if (ABB.Simulator.Global.card.headline == "Clear") {
							ABB.Simulator.Global.settingsChanged = false;
							/**
							 * Clear Indications and LEDs
							 */
							if ( ABB.Simulator.Global.dspposition == 0 && ABB.Simulator.Global.optionposition == 1) {
								var oES = ABB.Simulator.Global.GetErrorSimulationObject();
								var oSIM = ABB.Simulator.Global.GetSimulatorObject();									
														
								// when alarm is active
								if( ABB.Simulator.Global.isAlarm == true ) {
										oES.clearStartState();
										oES.clearTripFlags();
										ABB.Simulator.Global.isAlarm = false;
														
										var objLEDs = new ABB.Simulator.UI.LEDs();										
										objLEDs.SetLedStartState( ABB.Simulator.Global.Constants.LEDStateInactive );
										objLEDs.SetLedTripState( ABB.Simulator.Global.Constants.LEDStateInactive );				
								}
							}
							/**
							 * Clear Alarm LEDs
							 */
							if ( ABB.Simulator.Global.dspposition == 1 && ABB.Simulator.Global.optionposition == 1) {
								var objLEDs = new ABB.Simulator.UI.LEDs();
								objLEDs.SetLedProgrammableState(ABB.Simulator.Global.Constants.LEDAllProgrammable, ABB.Simulator.Global.Constants.LEDStateInactive );								
							}
							/**
							 * Clear Event List
							 */
							if ( ABB.Simulator.Global.dspposition == 2 && ABB.Simulator.Global.optionposition == 1) {
								var oES = ABB.Simulator.Global.GetErrorSimulationObject();
								oES.clearEventList();
							}
							ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
						}
						else if (ABB.Simulator.Global.card.headline == "IED test") {
							var oSLD = ABB.Simulator.Global.GetSingleLineDiagram();
							if ( ABB.Simulator.Global.dspposition == 0 && ABB.Simulator.Global.optionposition == 1) {
								oSLD.setTestMode(true);
							}
							else if (ABB.Simulator.Global.dspposition == 0 && ABB.Simulator.Global.optionposition == 0){
								oSLD.setTestMode(false);
							}
							ABB.Simulator.Global.selectedValue.activeoption = ABB.Simulator.Global.optionposition;
							ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.selectedValue.activeoption;
							ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
						}
						else {
							ABB.Simulator.Global.selectedValue.activeoption = ABB.Simulator.Global.optionposition;
							ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.selectedValue.activeoption;
							ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
						}
					break;
					case "sgoption":
						ABB.Simulator.Global.selectedValue.groups[ ABB.Simulator.Global.editGroupValue-1 ] = ABB.Simulator.Global.optionposition;
						ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
					break;
					case "numeric":
						if( ABB.Simulator.Global.selectedValue.action == "setpassword" ) {
							ABB.Simulator.Global.password = ABB.Simulator.Global.selectedValue.value;
						}
						
						// return original value if the value is over min and max values
						if( ABB.Simulator.Global.selectedValue.value*1 < ABB.Simulator.Global.selectedValue.min*1 || ABB.Simulator.Global.selectedValue.value*1 > ABB.Simulator.Global.selectedValue.max*1 ) {
								ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.storedValue;
						}
						
						ABB.Simulator.Global.selectedValue.value = ABB.Simulator.UI.CardMode.HideInsignificantNumbers(ABB.Simulator.Global.selectedValue.value, '0', '');
						//Save value if active setting group has changed
						if ( ABB.Simulator.Global.selectedValue.title == "Active group" ) {
							ABB.Simulator.Global.activeSettingGroup = ABB.Simulator.Global.selectedValue.value;
						}
						ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
					break;								
					case "sgnumeric":																		// return from SettingGroupMode
						// return original value if the value is over min and max values
						if( ABB.Simulator.Global.selectedValue.value*1 < ABB.Simulator.Global.selectedValue.min*1 || ABB.Simulator.Global.selectedValue.value*1 > ABB.Simulator.Global.selectedValue.max*1 ) {
								ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.storedValue;
						}
						ABB.Simulator.Global.selectedValue.value = ABB.Simulator.UI.CardMode.HideInsignificantNumbers(ABB.Simulator.Global.selectedValue.value, '0', '');
						ABB.Simulator.Global.selectedValue.groups[ABB.Simulator.Global.editGroupValue - 1] = ABB.Simulator.Global.selectedValue.value;
						ABB.Simulator.Global.card.mode = "SettingGroupMode";
						ABB.Simulator.UI.Display.RefreshDisplay();
					break;
					case "text":
						ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.selectedValue.value.replace(/^\s+|\s+$/g, '');
						ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
					break;
				}
			break;
			case "SettingGroupMode":		// to enter EditMode from SettingGroup value
				var access = this.CheckAccess();
				if ( access == true ) {
					ABB.Simulator.Global.binaryNumber = 0;
					ABB.Simulator.Global.card.mode = "EditMode";
					ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.selectedValue.groups[ABB.Simulator.Global.editGroupValue -1];
					ABB.Simulator.Global.storedValue = ABB.Simulator.Global.selectedValue.value;
					if (ABB.Simulator.Global.selectedValue.type == "sgoption") {
						ABB.Simulator.Global.optionposition = ABB.Simulator.Global.selectedValue.groups[ABB.Simulator.Global.editGroupValue-1];
					}
					ABB.Simulator.UI.Display.RefreshDisplay();
				}
			break;
		}
	}

	
	/**
	 * Function is called when HMI Esc button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonEsc		= function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0  && ABB.Simulator.UI.Dialog.dialogType != 1 && ABB.Simulator.UI.Dialog.dialogType != 2 ) return;
		// in case root mode has not been loaded, do nothing.
		if(ABB.Simulator.Global.card==null) {
			return;
		}
		
		if( ABB.Simulator.Global.showDialog && ABB.Simulator.UI.Dialog.dialogType == 4 ) {
			ABB.Simulator.Global.showDialog = false;
			ABB.Simulator.UI.Display.RefreshDisplay();
			return;
		}
		
		if( ABB.Simulator.Global.isClearMenu ) {
			if( ABB.Simulator.Global.showDialog ) {
				ABB.Simulator.Global.showDialog = false;
				ABB.Simulator.UI.Display.RefreshDisplay();
			}						
			return;
		}
		
		clearTimeout(ABB.Simulator.Global.timeoutMonitor);
		/**
		 * If user cancels login procedure
		 */
		if ( ABB.Simulator.Global.userLevel	!= 0 ) {
			ABB.Simulator.Global.showDialog	 = false;
		}
		else {
			ABB.Simulator.UI.Dialog.ShowAlertDialog();
			return;
		}
		ABB.Simulator.Global.isMonitor = false;	
		switch( ABB.Simulator.Global.card.mode ) {
				case "MenuNode":
				case "GroupMode":
				case "SettingGroupMode":
						if ( ABB.Simulator.Global.settingsChanged ) {
							ABB.Simulator.UI.Dialog.ModalDialog( "Commit settings?", "Question", "YesNoCancel", 0, "commitSettings" );
							ABB.Simulator.UI.Dialog.ShowDialog();
							return;
						}
						break;
				case "EditMode":	
						switch( ABB.Simulator.Global.selectedValue.type ) {
								case "option":																	// Cancel save
										ABB.Simulator.Global.selectedValue.activeoption = ABB.Simulator.Global.storedValue;
										ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
										break;
								case "numeric":
								case "text":
										ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.storedValue;
										ABB.Simulator.UI.CardMode.ShowXMLCard( ABB.Simulator.UI.Display.GetPageHistory() , "back" );
										break;
								case "sgnumeric":																		
										ABB.Simulator.Global.selectedValue.value = ABB.Simulator.Global.storedValue;
										ABB.Simulator.Global.card.mode = "SettingGroupMode";
										ABB.Simulator.UI.Display.RefreshDisplay();
										break;
								case "sgoption":
										ABB.Simulator.Global.selectedValue.groups[ABB.Simulator.Global.editGroupValue -1] = ABB.Simulator.Global.storedValue;
										ABB.Simulator.Global.card.mode = "SettingGroupMode";
										ABB.Simulator.UI.Display.RefreshDisplay();
										break;
						}
						break;
		}
	}
	
	/**
	 * Function is called when HMI Menu button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonMenu		= function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 ) return;
		
		// when clear menu is open
		if( ABB.Simulator.Global.card.id != ABB.Simulator.Global.Constants.XMLRootId ) {
			clearTimeout(ABB.Simulator.Global.timeoutMonitor);
			ABB.Simulator.Global.isClearMenu = false;
			ABB.Simulator.Global.isMonitor = false;
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.XMLRootId, "forward" );
		}
		else {
			ABB.Simulator.Global.isMonitor = true;
			ABB.Simulator.UI.Display.ClearPageHistory();
			ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.MeasMenuId, "forward" );
		}
		return;
	}
	
	/**
	 * Function is called when HMI Key button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonKey		= function () {
		if ( ABB.Simulator.Global.showDialog == false || ABB.Simulator.UI.Dialog.dialogType == 4 ) {
			if ( ABB.Simulator.Global.userLevel > 0 ) {
				ABB.Simulator.UI.Dialog.ModalDialog( "Do you want to log<br/>out?", "Question", "YesNo", 0, "logout" );
				ABB.Simulator.UI.Dialog.ShowDialog();
			}
			else {
				ABB.Simulator.UI.Dialog.LoginDialog();
				ABB.Simulator.UI.Dialog.ShowDialog();
			}
		}
	}
	
	/**
	 * Function is called when HMI Clear button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonClear	= function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 ) return;
		if( ABB.Simulator.Global.showDialog && ABB.Simulator.UI.Dialog.dialogType == 4 ) {
			ABB.Simulator.Global.showDialog = false;
			ABB.Simulator.UI.Display.RefreshDisplay();
		}
		clearTimeout(ABB.Simulator.Global.timeoutMonitor);
		ABB.Simulator.Global.isMonitor = false;
		ABB.Simulator.Global.isClearMenu = true;
		ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.ClearMenuId, "forward" );
		ABB.Simulator.UI.Display.RefreshDisplay();
	}
	
	/**
	 * Function is called when HMI Key button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonOn		= function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 ) return;
		//close the breaker in Fault Simulation Panel
		if ( ABB.Simulator.Global.stateLR == -1 ) {
			if ( ABB.Simulator.Global.breakerOpen ){
				if ( ABB.Simulator.Global.userLevel > 1 ) {
					ABB.Simulator.UI.Dialog.ModalDialog( "Close Breaker?", "Question", "YesNo", 0, "closeBreaker" );
					ABB.Simulator.UI.Dialog.ShowDialog();
				}
				else {
					ABB.Simulator.UI.Dialog.AlertDialog( "You can not control.<br/>Please login<br/>as operator.", "Information" );
					ABB.Simulator.UI.Dialog.ShowDialog();
				}
			}
		} else {
			if( ABB.Simulator.Global.breakerOpen ) {
				ABB.Simulator.UI.Dialog.AlertDialog( "Select failed!", "Error" );
				ABB.Simulator.UI.Dialog.ShowDialog();
			}
		}
	}

	
	/**
	 * Function is called when HMI Key button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonOff = function () {
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 ) return;
		if ( ABB.Simulator.Global.stateLR == -1 ) {
			if ( !ABB.Simulator.Global.breakerOpen ){
				if ( ABB.Simulator.Global.userLevel > 1 ) {
					if ( ABB.Simulator.Global.earthingOpen) {
						ABB.Simulator.UI.Dialog.ModalDialog( "Open Breaker?", "Question", "YesNo", 0, "openBreaker" );
						ABB.Simulator.UI.Dialog.ShowDialog();
					}
					else {
						//ABB.Simulator.UI.Dialog.AlertDialog( "Interlocking", "Warning" );						
						//ABB.Simulator.UI.Dialog.ShowDialog();
						alert("Interlocking");
					}
				}
				else {
					ABB.Simulator.UI.Dialog.AlertDialog( "You can not control.<br/>Please login<br/>as operator.", "Information" );
					ABB.Simulator.UI.Dialog.ShowDialog();
				}
			}
		}
		else {
			if( !ABB.Simulator.Global.breakerOpen ) {
				ABB.Simulator.UI.Dialog.AlertDialog( "Select failed!", "Error" );
				ABB.Simulator.UI.Dialog.ShowDialog();
			}
		}
	}
	
	/**
	 * Function is called when HMI Key button is pressed
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.OnButtonRL		= function () {
		
		/**
		 * If user is not logged in
		 */
		if (ABB.Simulator.Global.userLevel	== 0 ) return;
	
		if (ABB.Simulator.Global.userLevel < 2) {
			ABB.Simulator.UI.Dialog.SetPasswordDialog( 2 );
			ABB.Simulator.UI.Dialog.type = "LRpass"
			ABB.Simulator.UI.Dialog.ShowDialog();			
		}
		else {		
			changeLR();
		}
	}
	
	function changeLR() {
		var objLEDs = new ABB.Simulator.UI.LEDs();
		switch (ABB.Simulator.Global.stateLR) {
			case 0:
					ABB.Simulator.Global.stateLR = 1;
					objLEDs.SetRemoteLocalState('R', ABB.Simulator.Global.Constants.LEDStateYellow );
					break;
			case -1:
					ABB.Simulator.Global.stateLR = 0;
					objLEDs.SetRemoteLocalState('L', ABB.Simulator.Global.Constants.LEDStateInactive );
					objLEDs.SetRemoteLocalState('R', ABB.Simulator.Global.Constants.LEDStateInactive );
					break;
			case 1:
					ABB.Simulator.Global.stateLR = -1;
					objLEDs.SetRemoteLocalState('R', ABB.Simulator.Global.Constants.LEDStateInactive );
					objLEDs.SetRemoteLocalState('L', ABB.Simulator.Global.Constants.LEDStateYellow );
					break;
		}
	}
	
	/**
	 * Function sets single character in string at pointed location
	 * @param str - TARGET STRING	 
	 * @param index - CHARACTER INDEX IN TARGET STRING
	 * @param char - character that replaces old one
	 * @return new string
	 */
	function setCharAt(str,index,char) {
		if(index > str.length-1) return str;
		return str.substr(0,index) + char + str.substr(index+1);
	}
	
	/**
	 * <brief>
	 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
	 * @return what is the method returning
	 * @exception TYPEWHEN THROWN
	 * @see what else methods should be looked at
	 */
	this.CheckAccess = function () {
		if ( ABB.Simulator.Global.selectedValue.access == "Read" ) {
			ABB.Simulator.UI.Dialog.AlertDialog( "The parameter is<br/>Read Only.", "Information");
			ABB.Simulator.UI.Dialog.ShowDialog();
			return false;
		}
		else {
			switch( ABB.Simulator.Global.userLevel ) {
				case 1:		//Viewer
					if ( ABB.Simulator.Global.selectedValue.category == "basic" ) {
						ABB.Simulator.UI.Dialog.AlertDialog( "Parameter Access<br/>Error.", "Information");
						ABB.Simulator.UI.Dialog.ShowDialog();
						return false;
					}
					if ( ABB.Simulator.Global.selectedValue.category == "advanced" ) {
						ABB.Simulator.UI.Dialog.AlertDialog( "Parameter Access<br/>Error.", "Information");
						ABB.Simulator.UI.Dialog.ShowDialog();
						return false;
					}
				break;
				case 2:		//Operator
					if ( ABB.Simulator.Global.selectedValue.category == "basic" ) return true;
					if ( ABB.Simulator.Global.selectedValue.category == "advanced" ) {
						ABB.Simulator.UI.Dialog.AlertDialog( "Parameter Access<br/>Error.", "Information");
						ABB.Simulator.UI.Dialog.ShowDialog();
						return false;
					}
				break;
				case 3:		//Engineer		
					if ( ABB.Simulator.Global.selectedValue.category == "basic" ) return true;
					if ( ABB.Simulator.Global.selectedValue.category == "advanced" ) return true;
				break;
				case 4:		//Administrator						
					if ( ABB.Simulator.Global.selectedValue.category == "basic" ) return true;
					if ( ABB.Simulator.Global.selectedValue.category == "advanced" ) return true;
				break;
			}
		}
		return false;
	}
}
