﻿// Namespace: ABB.Simulator.UI.CardMode
/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.ShowXMLCard = function ( id, direction ) {
    var blnFound = false;
  
    if( id!="" && id!=null ) {
        for (i = 0; i < ABB.Simulator.Global.xmlCards.length; i++) {
             for (j = 0; j < ABB.Simulator.Global.xmlCards[i].childNodes.length; j++) {
                if( ABB.Simulator.Global.xmlCards[i].childNodes[j].nodeType != 1){ continue;}
				
				var child = ABB.Simulator.Global.xmlCards[i].childNodes[j].firstChild;
                
				if( child != null && child.parentNode.nodeName == "id" && child.nodeValue == id) {
                    ABB.Simulator.UI.CardMode.SetActiveCard( ABB.Simulator.Global.xmlCards[i] );
                    
										if( direction == "forward" ) {
												ABB.Simulator.UI.Display.PutPageHistory( ABB.Simulator.Global.currentid );
												ABB.Simulator.Global.ResetValues();
										}
										ABB.Simulator.Global.currentid = id;
										ABB.Simulator.UI.Display.RefreshDisplay();
										blnFound = true;
                    return;
                }
            }
        }
		    if( blnFound == false ) { 
		        alert( "The item is linking to a Card Id that doesn't exist!\n" + "linkToCardId: " + id + "\nCard not found!" );
		    }
	}
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.SetValueNodeList = function ( xmlNode ) {
    var xNode;
    var xNode2;
    var xNode3;
    var xNode4;
	var inputNode;
    
    for(loopX = 0; loopX<xmlNode.length; loopX++) {
        xNode =  xmlNode[ loopX ];
        if( xNode.nodeType != 1 ) continue;		//check empty nodes
        
        var datainput = new ABB.Simulator.UI.Display.DisplayInput(); 
        
        for( loopY = 0; loopY<xNode.childNodes.length; loopY++ ) {
		        xNode2 = xNode.childNodes[ loopY ];
		        if( xNode2.nodeType != 1 ) continue;		//check empty nodes
        
		        switch( xNode2.nodeName ) {
		    				case "id":
		    						datainput.valueid = xNode2.firstChild.nodeValue;
		    						break;
							case "input":
								//Values inside input tag
								for( loopInput = 0; loopInput<xNode2.childNodes.length; loopInput ++) {
									inputNode = xNode2.childNodes[ loopInput ];
									switch( inputNode.nodeName ) {
										case "type":
											if ( inputNode.firstChild != null ) 
												datainput.type = inputNode.firstChild.nodeValue;
										break;
										case "value":
											if ( inputNode.firstChild != null ) 
												datainput.value = inputNode.firstChild.nodeValue; //Replace(xNode2.text, " ", "_") & String(20, "_");
										break;
										case "min":
											if ( inputNode.firstChild != null ) 
												datainput.min = inputNode.firstChild.nodeValue; //Val("0" & xNode2.text)
										break;
										case "max":
											if ( inputNode.firstChild != null ) 
												datainput.max = inputNode.firstChild.nodeValue; //Val("0" & xNode2.text)
										break;
										case "title":
											if ( inputNode.firstChild != null ) 
												datainput.title = inputNode.firstChild.nodeValue;
										break;
										case "format":
											if ( inputNode.firstChild != null ) 
												datainput.format = inputNode.firstChild.nodeValue;
										break;
										case "linkToCardId":
											if ( inputNode.firstChild != null ) 
												datainput.link = inputNode.firstChild.nodeValue;
										break;
										case "maxlength":
											if ( inputNode.firstChild != null )
												datainput.maxlength = inputNode.firstChild.nodeValue; //Val("0" & xNode2.text) 
										break;
										case "options":
											for( loopZ = 0; loopZ<inputNode.childNodes.length; loopZ++ ) { 
					
												xNode3 = inputNode.childNodes[ loopZ ];
												if( xNode3.nodeType != 1 ) continue;		//check empty nodes
										
												switch( xNode3.nodeName ) {
													case "option":
														datainput.options[datainput.options.length] = xNode3.firstChild.nodeValue;
													break;
												}
											}
											datainput.activeoption = datainput.value;
									break;
									}
								}
							break;
							case "inclusive":
								datainput.inclusive = xNode2.firstChild.nodeValue;
							break;
							case "access":
								datainput.access = xNode2.firstChild.nodeValue;
							break;
							case "category":
								datainput.category = xNode2.firstChild.nodeValue;
							break;
							case "support":
								datainput.support = xNode2.firstChild.nodeValue;
							break;
							case "action":
		    					datainput.action = xNode2.firstChild.nodeValue;
							break;										
							case "password":
		    					datainput.password = xNode2.firstChild.nodeValue;
							break;
							case "unit":
								if ( xNode2.firstChild != null ) {
									datainput.unit = xNode2.firstChild.nodeValue;
									if (datainput.unit == "\n      " )
										datainput.unit = "";
								}
		    				break;										
							case "groups":
								for( loopZ = 0; loopZ<xNode2.childNodes.length; loopZ++ ) { 
									xNode3 = xNode2.childNodes[ loopZ ];
									if( xNode3.nodeType != 1 ) continue;		//check empty nodes
										switch( xNode3.nodeName ) {
											case "group":
												datainput.groups[datainput.groups.length] = xNode3.firstChild.nodeValue;
											break;
											}
								}	
		        			break;
							case "activeoption":
		    					datainput.activeoption = xNode2.firstChild.nodeValue;
		    				break;
							case "isBreaker":
								datainput.isbreaker = xNode2.firstChild.nodeValue;
							break; 
		    		}
		    }
		    ABB.Simulator.Global.valueNodeList[ABB.Simulator.Global.valueNodeList.length] = datainput;
    } 
}


/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.SetActiveCard = function ( xmlNode ) {
    var xNode;
    var xNode2;
    var xNode3;
    var xNode4;
    
    ABB.Simulator.Global.card = new ABB.Simulator.UI.Display.DisplayCard();
	
    var counter;
    var counter2;
    
    counter = 0;
    counter2 = 0;
    
    for(loopX = 0; loopX<xmlNode.childNodes.length; loopX++) {
    	
        if( xmlNode.childNodes[ loopX ].nodeType != 1 ) continue;		//check empty nodes
        xNode =  xmlNode.childNodes[ loopX ];
        
        switch( xmlNode.childNodes[ loopX ].nodeName ) {
			case "id":
				ABB.Simulator.Global.card.id = xNode.firstChild.nodeValue;
			break;			
			case "mode":
				ABB.Simulator.Global.card.mode = xNode.firstChild.nodeValue;
			break;	
			case "headline":
				ABB.Simulator.Global.card.headline = xNode.firstChild.nodeValue;
				break;
			case "help":
				if (xNode.firstChild == null) {
					ABB.Simulator.Global.card.help = "";
				}
				else {
					ABB.Simulator.Global.card.help = xNode.firstChild.nodeValue;
				}
			break;
			case "text":
				ABB.Simulator.Global.card.text = xNode.firstChild.nodeValue;
				break;
			case "menu":
				if( xNode.childNodes.length > 0) {
					for( loopY = 0; loopY<xNode.childNodes.length; loopY++ ) {
						xNode2 = xNode.childNodes[ loopY ];
						if( xNode2.nodeType != 1 ) continue;		//check empty nodes
						var displaycontent = new ABB.Simulator.UI.Display.DisplayContent();
						for( loopZ = 0; loopZ<xNode2.childNodes.length; loopZ++ ) { 
							xNode3 = xNode2.childNodes[ loopZ ];
							if( xNode3.nodeType != 1 ) continue;		//check empty nodes
							switch( xNode3.nodeName ) {
								case "linkToCardId":
									displaycontent.link = xNode3.firstChild.nodeValue;
								break;    
								case "text":
									displaycontent.text = xNode3.firstChild.nodeValue;
								break;				                            
								case "id":
									displaycontent.valueid = xNode3.firstChild.nodeValue;
								break;
							}           
						}
						ABB.Simulator.Global.card.content[ABB.Simulator.Global.card.content.length] = displaycontent;
					}
				}
			break;
        } 
    }

}


/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.DrawCardInMode = function () {
	switch( ABB.Simulator.Global.card.mode ) {
		case "RootMode":
			ABB.Simulator.UI.CardMode.DrawRootMode();
		break;
		case "MenuNode":
			ABB.Simulator.UI.CardMode.DrawMenuNode();
		break;
		case "GroupMode":
			ABB.Simulator.UI.CardMode.DrawGroupMode();
		break;
		case "EditMode":
			ABB.Simulator.UI.CardMode.DrawEditMode();
		break;
		case "SettingGroupMode":
			ABB.Simulator.UI.CardMode.DrawSettingGroupMode();
		break;
	}
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.getValueNodeIndex = function ( id ) {
	for( LoopX=0; LoopX<ABB.Simulator.Global.valueNodeList.length; LoopX++) {
		var valueNode = ABB.Simulator.Global.valueNodeList[ LoopX ];
		if( valueNode.valueid == id ) {
				return LoopX;
		}
	}
	alert( "ValueNode :" + id + " not found !" );
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.getValueNode = function ( id ) {
	if (!ABB.Simulator.Global.valueNodeList) return "";
	for( LoopX=0; LoopX<ABB.Simulator.Global.valueNodeList.length; LoopX++) {
		var valueNode = ABB.Simulator.Global.valueNodeList[ LoopX ];
		if( valueNode.valueid == id ) {
			if( valueNode.type == "sgnumeric" || valueNode.type == "sgoption") {
				return valueNode.groups[ ABB.Simulator.Global.activeSettingGroup - 1 ];
			} 
			else {
				return valueNode.value;
			}
		}
	}
	alert( "ValueNode :" + id + " not found !" );
	return "";
}


/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.setValueNode = function ( id, value ) {
	if (!ABB.Simulator.Global.valueNodeList) return false;
	for( LoopX=0; LoopX<ABB.Simulator.Global.valueNodeList.length; LoopX++) {
		var valueNode = ABB.Simulator.Global.valueNodeList[ LoopX ];				
		if( valueNode.valueid == id ) {
			if( valueNode.type == "sgnumeric" || valueNode.type == "sgoption") {
				valueNode.groups[ ABB.Simulator.Global.activeSettingGroup ] = value;
			}
			else {
				valueNode.value = value;
			}
			return true;
		}
	}
	alert( "ValueNode :" + id + " not found !" );
	return false;
}


/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.addSpace = function ( amount ) {
	var temp = "";
	for(i=0;i<amount;i++) {
		temp = temp + ' ';
	}
	return temp; 
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.DrawMenuNode = function () {
		var obj = document.getElementById('idDisplay');
		obj.className = 'display';
		var startPosition;
		var endPosition;
		//Add card headline
		if ( ABB.Simulator.Global.card.id == ABB.Simulator.Global.Constants.XMLRootId) {
			displaytext = ABB.Simulator.UI.CardMode.getValueNode(ABB.Simulator.Global.Constants.BayNameId) + "<br/>";
		}
		else {
			displaytext = ABB.Simulator.Global.card.headline + "<br/>";
		}
		// Calkulete row where display rendering starts
		if (ABB.Simulator.Global.dspposition < ABB.Simulator.Global.Constants.DisplayRows ){
			startPosition = 0;
			if (startPosition + ABB.Simulator.Global.Constants.DisplayRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = ABB.Simulator.Global.Constants.DisplayRows;
			}
		}
		else{
			startPosition = ABB.Simulator.Global.dspposition - (ABB.Simulator.Global.Constants.DisplayRows - 1);
			if (startPosition + ABB.Simulator.Global.Constants.DisplayRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = startPosition + ABB.Simulator.Global.Constants.DisplayRows;
			}
		}
		if (ABB.Simulator.Global.card.id == ABB.Simulator.Global.Constants.EventMenuId) {
			var oES = ABB.Simulator.Global.GetErrorSimulationObject();
			var event = oES.getEvent(ABB.Simulator.Global.dspposition);
			if (event != null) {
				displaytext = event;
				displaytext = "(" + (ABB.Simulator.Global.dspposition + 1) + "/50)  " + displaytext;
			}
			ABB.Simulator.Global.display.refresh( displaytext );
			return;
		}
		//Draw menu elemets
		if (ABB.Simulator.Global.card != null){
			for (var i = startPosition; i < endPosition; i++){
				if(ABB.Simulator.Global.card.content[i].text != null) {
					if (i ==  ABB.Simulator.Global.dspposition){ 
						displaytext += "<b>";
					}
					displaytext += ABB.Simulator.Global.card.content[i].text;
					displaytext += "<br/>";
				}
			}
		}
		//Show string on display
		ABB.Simulator.Global.display.refresh( displaytext );
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */	
ABB.Simulator.UI.CardMode.DrawGroupMode = function () {
		var title = "";
		var unit = "";
		var value = "";
		var format = "";
		var valueid = "";
		var _id = new Array("idL1", "idL11", "idL2", "idL21", "idL3", "idL31", "idIO", "idIO1");
		var _isMeasure = false;
		var startPosition = 0;
		var endPosition = 0;
		var parameterRows = 0;
	
		var obj = document.getElementById('idDisplay');
		index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].link );		// Select value from the valueNodeList
		ABB.Simulator.Global.emDspposition = ABB.Simulator.Global.dspposition;		//Mark current dspposition to be used in edit mode
		ABB.Simulator.Global.selectedValue = ABB.Simulator.Global.valueNodeList[ index ];		// store selected value to global variable
		
		if( ABB.Simulator.Global.card.headline == "Measurements" ) ABB.Simulator.Global.isMonitor = true;
		
		//Add card headline
		if ( ABB.Simulator.Global.isMonitor) {
			parameterRows = ABB.Simulator.Global.Constants.DisplayRows;
			displaytext = ABB.Simulator.UI.CardMode.getValueNode(ABB.Simulator.Global.Constants.BayNameId) + "<br/>";
		}
		else {
			parameterRows = Math.round((ABB.Simulator.Global.Constants.DisplayRows/2) - 1);
			displaytext = ABB.Simulator.Global.card.headline + "<br/>";
		}
		
		if (ABB.Simulator.Global.dspposition < parameterRows ){
			startPosition = 0;
			if (startPosition + parameterRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = parameterRows;
			}
		}
		else{
			startPosition = ABB.Simulator.Global.dspposition - (parameterRows - 1);
			if (startPosition + parameterRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = startPosition + parameterRows;
			}
		}
		
		function getSimulatorWindow(){
			var objFrm = null;
			try{
				objFrm = top.parent.frmContent.frmContentItem;
			}catch(e){
				alert('Can\'t connect to simulator!');
			}
			return objFrm;	
		}
		
		//Loop trough the card to display all rows
		if (ABB.Simulator.Global.card != null){
			for (var i = startPosition; i < endPosition; i++){
				index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );
				var currentCard = ABB.Simulator.Global.valueNodeList[ index ];
				switch( currentCard.type ) {
					case "numeric":			
						if(ABB.Simulator.Global.card.content[i].text != null) {
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
							displaytext += ABB.Simulator.Global.card.content[i].text;
							if( ABB.Simulator.Global.isMonitor ) {
								clearTimeout(ABB.Simulator.Global.timeoutMonitor);
								displaytext += ABB.Simulator.UI.CardMode.getMeasValue( ABB.Simulator.Global.card.content[i].text );
								ABB.Simulator.Global.timeoutMonitor = setTimeout("ABB.Simulator.UI.CardMode.ShowXMLCard(ABB.Simulator.Global.Constants.MeasMenuId, 'refresh' )", 1000);
							}
							else {
								var index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );// Select value from the valueNodeList
								displaytext += "<br/>";
								if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
								displaytext += "=" + ABB.Simulator.Global.valueNodeList[ index ].value;	// display  value on screen
								if (ABB.Simulator.Global.valueNodeList[ index ].unit != null) {
									displaytext += " " + ABB.Simulator.Global.valueNodeList[ index ].unit
								}
							}
							displaytext += "<br/>";
						}
					break;				
					case "sgnumeric":
						if(ABB.Simulator.Global.card.content[i].text != null) {
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
							displaytext += ABB.Simulator.Global.card.content[i].text;
							var index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );// Select value from the valueNodeList
							displaytext += "<br/>";
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
							numvalue = "=" + ABB.Simulator.Global.valueNodeList[ index ].groups[ ABB.Simulator.Global.editGroupValue -1];		// display  value on screen
							if (ABB.Simulator.Global.valueNodeList[ index ].unit != null) {
								numvalue += " " + ABB.Simulator.Global.valueNodeList[ index ].unit;
							}
							displaytext += numvalue;
							displaytext += ABB.Simulator.UI.CardMode.addSpace(19 - numvalue.length) + "#"
						}
						displaytext += "<br/>";
					break;
					case "option":
						if(ABB.Simulator.Global.card.content[i].text != null) {
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; } //Mark active row
							displaytext += ABB.Simulator.Global.card.content[i].text;
							var index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );// Select value from the valueNodeList
							displaytext += "<br/>";
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; } //Mark active row
							displaytext += "=" + ABB.Simulator.Global.valueNodeList[ index ].options[ currentCard.activeoption ];		// display  value on screen
							displaytext += "<br/>";
						}
					break;
					case "sgoption":
						if(ABB.Simulator.Global.card.content[i].text != null) {
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; } //Mark active row
							displaytext += ABB.Simulator.Global.card.content[i].text;
							var index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );// Select value from the valueNodeList
							//TODO: Change to default option
							displaytext += "<br/>";
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; } //Mark active row
							value = currentCard.options[ currentCard.groups[ABB.Simulator.Global.editGroupValue-1] ];		// display  value on screen
							value = "=" + value;
							displaytext += value;
							displaytext += ABB.Simulator.UI.CardMode.addSpace(19 - value.length) + "#";
							displaytext += "<br/>";
						}
					break;
					case "text":
						if(ABB.Simulator.Global.card.content[i].text != null) {
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
							displaytext += ABB.Simulator.Global.card.content[i].text;
							var index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[i].link );		// Select value from the valueNodeList
							displaytext += "<br/>";
							if (i ==  ABB.Simulator.Global.dspposition){ displaytext += "<b>"; }
							displaytext += "=" + ABB.Simulator.Global.valueNodeList[ index ].value;		// display  value on screen
							displaytext += "<br/>";
						}
					break;	
				}
			}
		}
		
		if( ABB.Simulator.Global.selectedValue.support != null) {
			if(ABB.Simulator.Global.selectedValue.support == '0') {
				obj.className = 'displayUnsuported';
			}
			else {
				obj.className = 'display';
			}
		}
		
		ABB.Simulator.Global.display.refresh( displaytext );
		
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.DrawEditMode = function () {
		
		var type = ABB.Simulator.Global.selectedValue.type;
		var displaytext = "";
		
		/**
		 * Calculate rows that fit on screen
		 */
		parameterRows = Math.round((ABB.Simulator.Global.Constants.DisplayRows/2) - 1);
		
		if (ABB.Simulator.Global.dspposition < parameterRows ){
			startPosition = 0;
			if (startPosition + parameterRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = parameterRows;
			}
		}
		else{
			startPosition = ABB.Simulator.Global.dspposition - (parameterRows - 1);
			if (startPosition + parameterRows > ABB.Simulator.Global.card.content.length){
				endPosition = ABB.Simulator.Global.card.content.length;
			}
			else {
				endPosition = startPosition + parameterRows;
			}
		}
		switch( type ) {
			case "numeric":
			case "option":
			case "text":
				displaytext = ABB.Simulator.Global.card.headline + "<br/>";
				/**
				 * Loop trough the displayed rows
				 */
				for ( rowIndex = startPosition; rowIndex < endPosition; rowIndex++){
					displaytext += ABB.Simulator.Global.card.content[rowIndex].text + "<br/>";
					/**
					 * Get value node of current row
					 */
					index = ABB.Simulator.UI.CardMode.getValueNodeIndex( ABB.Simulator.Global.card.content[rowIndex].link );
					var currentValueNode = ABB.Simulator.Global.valueNodeList[ index ];
					
					if (rowIndex ==  ABB.Simulator.Global.dspposition) {
						switch( currentValueNode.type ) {
							case "numeric":
								if ( ABB.Simulator.Global.showMin == true ) {
									value = "↓";
									if (ABB.Simulator.Global.selectedValue.min > 0)
										value += "+";
									value += new Number(ABB.Simulator.Global.selectedValue.min).numberFormat(ABB.Simulator.Global.selectedValue.format);
								}else if ( ABB.Simulator.Global.showMax == true ) {
									value = "↑";
									if (ABB.Simulator.Global.selectedValue.max > 0)
										value += "+";
									value += new Number(ABB.Simulator.Global.selectedValue.max).numberFormat(ABB.Simulator.Global.selectedValue.format);
								}
								else {
									/**
									* Format number
									*/
									value = ABB.Simulator.Global.selectedValue.value;
									value = new Number(value).numberFormat(ABB.Simulator.Global.selectedValue.format);
									value = ABB.Simulator.UI.CardMode.HideInsignificantNumbers(value, '0', '_');
									if (ABB.Simulator.Global.selectedValue.value >  0 ) {
										value = "+" + value;
									}
									value = "↕" + value;
								}
								value = MarkCursorPosition(value);
								if (currentValueNode.unit != null) {
									value += " " + currentValueNode.unit;
								}
							break;
							case "option":
								value = "<b>" + currentValueNode.options [ ABB.Simulator.Global.optionposition ];
							break;
							case "text":
								value = currentValueNode.value;
								if (value.length > ABB.Simulator.Global.Constants.DisplayColumns) {
									value = value.substring(0,ABB.Simulator.Global.Constants.DisplayColumns-1);
								}
								var temp = '';
								for (k=0;k<ABB.Simulator.Global.Constants.DisplayColumns-value.length-1;k++) {
									temp += ' ';
								}
								value += temp;
								currentValueNode.value = value;
								value = MarkCursorPosition(value);
							break;
						}
					} else {
						switch( currentValueNode.type ) {
							case "numeric":
								value = currentValueNode.value;
								if (currentValueNode.unit != null) {
									value +=" " + currentValueNode.unit;
								}
							break;
							case "text":
								value = currentValueNode.value;
							break;
							case "option":
								value = currentValueNode.options[ currentValueNode.activeoption ];
							break;
							case "sgnumeric":
								value =  currentValueNode.groups[ ABB.Simulator.Global.editGroupValue - 1 ];
								if (currentValueNode.unit != null) {
									value +=" " + currentValueNode.unit;
								}
								space = ABB.Simulator.UI.CardMode.addSpace(18 - value.length);
								value += space + "#";
							break;
							case "sgoption":
								value = currentValueNode.options[ currentValueNode.groups[ ABB.Simulator.Global.editGroupValue - 1] ];
								if (value == null) value = currentValueNode.options[ 0 ];
								value += ABB.Simulator.UI.CardMode.addSpace(18 - value.length) + "#";
							break;
						}
					}
					displaytext += "=" + value;
					displaytext += "<br/>";
				}
			break;	
			case "sgnumeric":
				displaytext = "SG" + ABB.Simulator.Global.editGroupValue + ": " + ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].text + "<br/>";
				/**
				 * Loop trough setting groups
				 */
				for (i = 0; i < 4; i++) {
					/**
					 * Add '*' for active setting group
					*/
					if( i == ABB.Simulator.Global.activeSettingGroup - 1 ) {
						displaytext += "*";			
					}
					else {
						displaytext += " ";
					}
					
					if ( i == ABB.Simulator.Global.editGroupValue - 1) {
						/**
						 * Show min & max values
						 */
						if ( ABB.Simulator.Global.showMin == true ) {
							value = "↓";
							if (ABB.Simulator.Global.selectedValue.min > 0)
								value += "+";
							value += new Number(ABB.Simulator.Global.selectedValue.min).numberFormat(ABB.Simulator.Global.selectedValue.format);
						}else if ( ABB.Simulator.Global.showMax == true ) {
							value = "↑";
							if (ABB.Simulator.Global.selectedValue.max > 0)
								value += "+";
							value += new Number(ABB.Simulator.Global.selectedValue.max).numberFormat(ABB.Simulator.Global.selectedValue.format);
						}
						else {
							/**
							 * Format number
							 */
							value = ABB.Simulator.Global.selectedValue.value;
							value = new Number(value).numberFormat(ABB.Simulator.Global.selectedValue.format);
							value = ABB.Simulator.UI.CardMode.HideInsignificantNumbers(value, '0', '_');
							if (ABB.Simulator.Global.selectedValue.value >  0 ) {
								value = "+" + value;
							}
							value = "↕" + value;
						}
						value = MarkCursorPosition(value);
						displaytext += "[" + (i + 1) + "]=" + value;
					}
					else {
						displaytext += "[" + (i + 1) + "]=" + ABB.Simulator.Global.selectedValue.groups[ i ];	
					}
					if (ABB.Simulator.Global.selectedValue.unit != null) {
						displaytext += " " + ABB.Simulator.Global.selectedValue.unit;
					}
					displaytext += "<br/>";
				}
			break;
			case "sgoption":
				//if(ABB.Simulator.Global.card.content[i].text != null) {
					displaytext = "SG" + ABB.Simulator.Global.editGroupValue + ": " +   ABB.Simulator.Global.card.content[ABB.Simulator.Global.dspposition].text + "<br/>";
					for (i = 0; i < 4; i++) {
						if( i == ABB.Simulator.Global.activeSettingGroup - 1 ) displaytext += "*";
						else displaytext += " ";
						if ( i == ABB.Simulator.Global.editGroupValue - 1 ) {
							displaytext += "[" + (i + 1) + "]=<b>" + ABB.Simulator.Global.selectedValue.options[ ABB.Simulator.Global.optionposition ] + "</b>";
						}
						else {
							displaytext += "[" + (i + 1) + "]=" + ABB.Simulator.Global.selectedValue.options[ABB.Simulator.Global.selectedValue.groups[ i ] ];
						}
					displaytext += "<br/>";
					}
				//}
			break;
		}
		ABB.Simulator.Global.display.refresh( displaytext );
}

/**
 * Function marks cursorposition on text line using <b></b> tags
 * @param line - text line to be edited
 * @return edited text line
 */
MarkCursorPosition = function(line) {
	var start, val, end;
	line = line.toString();
	start = line.substring(0, (line.length - (ABB.Simulator.Global.cursorpos + 1)));
	val = line.substring((line.length - (ABB.Simulator.Global.cursorpos + 1)), (line.length - (ABB.Simulator.Global.cursorpos + 1)) + 1);
	end = line.substring((line.length - ABB.Simulator.Global.cursorpos), line.length);
	return start + "<b>" + val + "</b>" + end;
}


/**
 * Function hides insignificant zeroes at the beginning
 * @param line - text line to be edited
 * @param oldChar - char to search
 * @param newChar - new character
 * @return edited text line
 */
ABB.Simulator.UI.CardMode.HideInsignificantNumbers = function(line, oldChar, newChar) {
	var firstZero = line.indexOf(oldChar);
	var firstNonZero = line.length;
	for (var j=1; j<10;j++) {
		temp = line.indexOf(j.toString());
		if ( temp != -1 && temp < firstNonZero)
			firstNonZero = temp;
	}
	var decimalDelimitter =  line.indexOf('.');
	if (decimalDelimitter != -1 ) {
		while ( firstZero <= (decimalDelimitter - 2 ) && firstZero != -1) {
			line = setCharAt(line,firstZero,newChar)
			firstZero = line.indexOf(oldChar);
			if (newChar == '')
				decimalDelimitter--;
		}
	}
	else {
		while (firstZero < firstNonZero  && firstZero != -1 && firstZero < line.length-1) {
			line = setCharAt(line,firstZero,newChar)
			firstZero = line.indexOf(oldChar);
			if (newChar == '')
				firstNonZero--;
		}
	}
	return line;
}

/**
 * Function sets single character in string at pointed location
 * @param str - TARGET STRING	 
 * @param index - CHARACTER INDEX IN TARGET STRING
 * @param char - character that replaces old one
 * @return new string
 */
function setCharAt(str,index,char) {
	if(index > str.length-1) return str;
	return str.substr(0,index) + char + str.substr(index+1);
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.DrawSettingGroupMode = function () {
	var obj = document.getElementById('idDisplay');
	switch( ABB.Simulator.Global.selectedValue.type ) {
		case "sgnumeric":
			displaytext = "SG" + ABB.Simulator.Global.editGroupValue + ": " +   ABB.Simulator.Global.card.content[ABB.Simulator.Global.emDspposition].text;
			for (i = 1; i <= 4; i++) {
				displaytext += "<br/>"
				if( i == ABB.Simulator.Global.editGroupValue ) displaytext += "<b>";
				if( i == ABB.Simulator.Global.activeSettingGroup ) displaytext += "*";
				else displaytext += " ";
				//Show values
				displaytext += "[" + i + "]=" + ABB.Simulator.Global.selectedValue.groups[ i - 1 ];
				if (ABB.Simulator.Global.selectedValue.unit != null) {
					displaytext += " " + ABB.Simulator.Global.selectedValue.unit;
				}
			}
		break;
		case "sgoption":
			displaytext = "SG" + ABB.Simulator.Global.editGroupValue + ": " +   ABB.Simulator.Global.card.content[ABB.Simulator.Global.emDspposition].text;
			for (i = 1; i <= 4; i++) {
				displaytext += "<br/>"
				if( i == ABB.Simulator.Global.editGroupValue ) displaytext += "<b>";
				if( i == ABB.Simulator.Global.activeSettingGroup ) displaytext += "*";
				else displaytext += " ";
				//Show values
				displaytext += "[" + i + "]=" + ABB.Simulator.Global.selectedValue.options[ABB.Simulator.Global.selectedValue.groups[ i - 1 ]];
			}
		break;
	}
	ABB.Simulator.Global.display.refresh( displaytext );		
}

/**
 * Function is called when HMI Enter button is pressed
 * @param PARAMETERNAME - PARAMETER DESCRIPTION (as many @param tags as needed)
 * @return what is the method returning
 * @exception TYPEWHEN THROWN
 * @see what else methods should be looked at
 */
ABB.Simulator.UI.CardMode.getMeasValue = function ( text ) {
		var variation = 5;
		var oES = ABB.Simulator.Global.GetErrorSimulationObject();		
		var value = 0;
		returnText = '';
		
		if (!ABB.Simulator.Global.breakerOpen) {
			if ( text == "IL1-A" ) {
				value = oES.GetInjectedValue(0);
			}
			else if ( text == "IL2-A" ) {
				value =  oES.GetInjectedValue(1);
			}
			else if ( text == "IL3-A" ) {
				value = oES.GetInjectedValue(2);
			}
			else if ( text == "IL1-dem-A" ) {
				value =  oES.GetInjectedValue(0);
			}
			else if ( text == "IL2-dem-A" ) {
				value =  oES.GetInjectedValue(1);
			}
			else if ( text == "IL3-dem-A" ) {
				value =  oES.GetInjectedValue(2);
			}
			else if ( text == "I0-A" ) {				
				value =  oES.GetInjectedValue(3);
			}
			else if ( text == "U0-kV" ) {
				variation = 0.3;
				value = oES.GetInjectedValue(4);
			}
			else if ( text == "Ng-Seq-A" ) {
				value = oES.GetSequenceCurrent(0);
			}
			else if ( text == "Ps-Seq-A" ) {
				value =  oES.GetSequenceCurrent(1);
			}
			else if ( text == "Zro-Seq-A" ) {
				value =  oES.GetSequenceCurrent(2);
			}
			else {
				value = 0;
			}
		} else {
			value = 0;
		}
		
		if(value > variation){
			value += Math.sin(Math.random(360))*variation*2-variation;
		}
		
		value = String(new Number(value).numberFormat("#.#"));
		
		if ( ABB.Simulator.Global.isMonitor ) {
			returnText = ABB.Simulator.UI.CardMode.addSpace(20-text.length-value.length) + value;
		} else {
			returnText = "=" + value;
		}
		
		return returnText;
}
