// Namespace: ABB.Simulator.UI.LEDs
/*
Available LED states:
	ABB.Simulator.Global.Constants.LEDStateInactive
	ABB.Simulator.Global.Constants.LEDStateGreen
	ABB.Simulator.Global.Constants.LEDStateYellow
	ABB.Simulator.Global.Constants.LEDStateRed	
	ABB.Simulator.Global.Constants.LEDStateGreenBlinking
	ABB.Simulator.Global.Constants.LEDStateYellowBlinking	
	ABB.Simulator.Global.Constants.LEDStateRedBlinking

LEDId can be 0-7 or ABB.Simulator.Global.Constants.LEDAllProgrammable
*/

ABB.Simulator.UI.LEDs	= function () {
	/*
	 * Public Functions
	 */
	this.SetLedReadyState			= function ( ledState ) {
		var img = getImageFromState( ledState, 'gray' );
		document.getElementById('idLEDReady').src = img;
	}
	
	this.SetLedStartState			= function ( ledState ) {
		var img = getImageFromState( ledState, 'gray' );
		document.getElementById('idLEDStart').src = img;
	}
	
	this.SetLedTripState			= function ( ledState ) {
		var img = getImageFromState( ledState, 'gray' );
		document.getElementById('idLEDTrip').src = img;
	}

	/*this.SetLedIndicatorState		= function ( ledState ) {
		var img = getImageFromState( ledState );
		document.getElementById('idLEDIndicator').src = img;
	}*/
	
	 
	this.SetLedProgrammableState	= function ( LEDId, ledState ) {
		if (LEDId == ABB.Simulator.Global.Constants.LEDAllProgrammable) {
			for (i = 0; i < 11 ; i++) {
				var img = getImageFromState( ledState, 'dark' );
				document.getElementById('idLEDProgrammable' + i).src = img;
			}
		}else {
			var img = getImageFromState( ledState, 'dark' );
			document.getElementById('idLEDProgrammable' + LEDId).src = img;
		}
	}
	
	this.SetRemoteLocalState = function (LEDId, ledState) {
		var img = getImageFromState( ledState, 'blue' );		
		if (LEDId == 'L') {
			document.getElementById('idLEDl').src = img;
		}		
		if (LEDId == 'R') {
			document.getElementById('idLEDr').src = img;
		}					
	}
	
	this.ResetAll					= function () {
		this.SetLedReadyState(ABB.Simulator.Global.Constants.LEDStateInactive);
		this.SetLedStartState(ABB.Simulator.Global.Constants.LEDStateInactive);
		this.SetLedTripState(ABB.Simulator.Global.Constants.LEDStateInactive);
		//this.SetLedIndicatorState(ABB.Simulator.Global.Constants.LEDStateInactive);
		this.SetLedProgrammableState(ABB.Simulator.Global.Constants.LEDAllProgrammable, ABB.Simulator.Global.Constants.LEDStateInactive);
		this.SetRemoteLocalState('L', ABB.Simulator.Global.Constants.LEDStateInactive);
		this.SetRemoteLocalState('R', ABB.Simulator.Global.Constants.LEDStateInactive);
	}


	/*
	 * Private Functions
	 */
	function getImageFromState( ledState, background ) {
		var folder = 'ied_images/';

		switch ( ledState ) {
		case ABB.Simulator.Global.Constants.LEDStateInactive:
			return folder + 'led_off_' + background + '.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateGreen:
			return folder + 'led_green_' + background + '.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateYellow:
			return folder + 'led_yellow_' + background + '.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateRed:
			return folder + 'led_red_' + background + '.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateGreenBlinking:
			return folder + 'led_green_blinking.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateYellowBlinking:
			return folder + 'led_yellow_blinking.gif';
			break;
		case ABB.Simulator.Global.Constants.LEDStateRedBlinking:
			return folder + 'led_red_blinking.gif';
			break;
		}
	}
	
}
